Subject: identifying parts

From: Dan Wing <[email-masked]>
Date: Wed, 21 Feb 2001 09:11:11 -0800 (PST)

This question is related to
draft-maeda-faxwg-fax-processing-status-00.txt.

A long time ago, I recall that some ifax sending devices would (or
could) send a multiple pages as multiple one-page TIFF
attachments.  

Here is a description of several different valid messages which describe
the problem I see with the current proposal in
draft-maeda-faxwg-fax-processing-status-00.txt.  The problem is that it
cannot identify the "page" successfully -- the definition of a page is
different from the sender and the receiver's view.  Email allows
much richer operation than scanning, transmitting, and printing.  This
richer operation means a straight-forward "page NNN failed" is not
sufficient for email.

A proposal to resolve this problem is below.  The proposal allows
operation as described in draft-maeda-faxwg-fax-processing-status-00.txt
while also allowing the richer operation of email.

Method 1:

  From: [email-masked]
  To: [email-masked]
  Subject: 3 page fax
  Message-ID: <[email-masked]>
  Date: 1 Jan 2001 01:00:00 -0800
  Content-Type: multipart/mixed; boundary=ABC

  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64

  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ

  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
 
  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
 
  --ABC--

Method 2:

  From: [email-masked]
  To: [email-masked]
  Subject: 3 page fax
  Message-ID: <[email-masked]>
  Date: 1 Jan 2001 01:00:00 -0800
  Content-Type: multipart/mixed; boundary=ABC

  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ

  --ABC--

Method 3:

  From: [email-masked]
  To: [email-masked]
  Subject: 3 page fax
  Message-ID: <[email-masked]>
  Date: 1 Jan 2001 01:00:00 -0800
  Content-Type: multipart/mixed; boundary=ABC
 
  --ABC
  Content-type: text/plain

                         FAX COVERSHEET

                From:     Jim
                To:       Susan
                Date:     1 Jan 2001 01:00:00, Pacific Time
                Contact:  [email-masked], 408-555-1212

  Susan,

  Here is the fax you requested.  There should be 4 pages total
  (this coversheet, plus 3 pages of the fax content itself).

  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
 
  --ABC--

To support non-ASCII languages on the coversheet, the first part in Method
3 could be image/tiff which contains a graphical representation of the
coversheet.

Method 4:

  From: [email-masked]
  To: [email-masked]
  Subject: 3 page fax
  Message-ID: <[email-masked]>
  Date: 1 Jan 2001 01:00:00 -0800
  Content-Type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ

Method 5:

  From: [email-masked]
  To: [email-masked]
  Subject: your two faxes: Sumerset, Egghead
  Content-Type: multipart/mixed; boundary=ABC
  Date: 1 Jan 2001 01:00:00 -0800
  Message-ID: <[email-masked]>
  
  --ABC
  Content-type: text/plain
 
                         FAX COVERSHEET
 
                From:     Jim
                To:       Susan
                Date:     1 Jan 2001 01:00:00, Pacific Time
                Contact:  [email-masked], 408-555-1212
 
  Susan,
 
  Here are your two faxes.  The first one is a 3 page fax from
  Sumerset, Inc.  The second one is a 9 page fax from Egghead.

  Thanks.
  Jim

  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
 
  --ABC
  content-type: image/tiff
  content-transfer-encoding: base64
 
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
  EJKFJFKEJKEFJFKJEFJKEJFEJFKEJ
 
  --ABC--

I _believe_ that most dedicated ifax devices use Method 4, above.  I
believe most of the typical mailers (Netscape, Eudora, Outlook) would use
Method 2 or Method 3, above.

I feel it is critical that any MDN or DSN response indicating a portion of
a message was successfully or unsuccessfully processed must also indicate
which MIME part is being described in the MDN or DSN reponse -- it is NOT
as simple as the "page" having the problem, especially if Method 1 is used
-- they are all page "1" from the view of the sender.  Method 1 is a valid
message format and is allowed, so we must handle it correctly.

I propose we require the use of Content-ID to identify MIME parts.  This
identification allows the MDN to indicate which part(s) were successfully
or unsuccessfully processed.

Content-ID is described in RFC2045, section 7.  Its use is discussed in
RFC2046.

-Dan Wing

---

From: "Eric Burger" <[email-masked]>
Date: Thu, 22 Feb 2001 04:33:01 -0500

This issue was fully addressed by partial non-delivery notification (PNDN).
Would that be an appropriate approach?

The draft has expired.  If we want to discuss it, I can resubmit it as a fax
WG item.  However, I believe that would reset it to -00, which means I would
have to submit it today.

--
- Eric

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On
> Behalf Of Dan Wing
> Sent: Wednesday, February 21, 2001 12:11 PM
> To: IETF Internet Fax WG
> Cc: MAEDA toru
> Subject: identifying parts
[snip]

---

From: MAEDA toru <[email-masked]>
Date: Thu, 22 Feb 2001 20:35:55 +0900

Tamura-san

Are there any description about these Methods described by Wing-san in
the implementation guide?

Regards.

Toru Maeda

>Content-ID is described in RFC2045, section 7.  Its use is discussed in

--------------------
MAEDA TORU
MIE Development Div. 2
CANON Inc.
--------------------

---

From: MAEDA toru <[email-masked]>
Date: Thu, 22 Feb 2001 21:29:51 +0900

Wing-san

I got data for ifax devices about these Methods during the Ifax 
communication test in 1999.
There were three types of MIME type usage in the ifax devices.

Type-1= Method 4
No Multi-part
one tiff file

Type-2= Method 2
Content-Type:Multipart/mixed
Multi-part with one tiff file part

Type-3= Method 3 (Not completely same in text part)
Content-Type:Multipart/mixed
Multi-part with one Text part and one tiff file part

Some manufacturers want to suppress printing
Multi-part Text part in the ifax receiver,
since the text is just information to PC client such as;
"There is a TIFF file in this mail, which sent from an Internet Facsimile."
"An image data has been attached to this E-mail message and image data is 
the Tiff file format."
"An image data in TIFF-F format has been attached to this email.
You can download the TIFF-F Image Viewer from the following URL addresses."
etc.

Any way, ifax should send one tiff file, so there will be no confusion
of page-by-page confirmation processing one tiff file.

Regards.

Toru Maeda

--------------------
MAEDA TORU
MIE Development Div. 2
CANON Inc.
--------------------

---

From: Hiroshi Tamura <[email-masked]>
Date: Fri, 23 Feb 2001 08:33:58 +0900 (JST)

MAEDA-san,

> the implementation guide?

No. We do not have any descriptions about page-by-page confirmation
in our guide.

Regards,
--
Hiroshi Tamura, Ricoh Company, LTD.
E-mail: [email-masked]

---

From: Dan Wing <[email-masked]>
Date: Thu, 22 Feb 2001 15:52:55 -0800

>You can download the TIFF-F Image Viewer from the following URL 

Throwing away parts of an email is a scary assumption.

With almost all mailers supporting MIME today, such boilerplate instructing 
a user on how to view an attachment seems unnecessary.  Certainly users 
requiring non-ASCII character sets are going to use MIME-aware mailers -- 
it's the only standard way to view text without a reader!

>of page-by-page confirmation processing one tiff file.

How would an ifax receiver be restricted to only receive this one 
method?  It seems we need correct behavior for all the valid types of email 
messages that an ifax may utilize.  If we don't, why use SMTP?

-d

---

From: MAEDA toru <[email-masked]>
Date: Mon, 26 Feb 2001 17:37:18 +0900

Tamura-san

I think we need some description about DSN and MDN
when multiple TIFF files are received,
in the implementers guide.

I do not mean that the partial deliver notification is required in the 
implementers guide.

Regards.

Toru Maeda

>No. We do not have any descriptions about page-by-page confirmation

-----------------------------------
キヤノン株式会社
映像事務機MIE推進センター
映像事務機MIE第２開発部
前田　徹
146-8501　東京都大田区下丸子３−３０−２
電話　03-3757-9738、FAX　03-3757-8205
-----------------------------------

---

From: Hiroshi Tamura <[email-masked]>
Date: Mon, 26 Feb 2001 18:02:32 +0900 (JST)

MAEDA-san,

> in the implementers guide.

Fortunately, we alread have. See Section 4.4.5.
---------------------------------------------------------------------------
4.4.5 Receiving Multiple TIFF-FX Attachments

   A received email message could contain multiple TIFF-FX attachments
   and each distinct TIFF-FX file may use different encoding and/or
   resolution. A received email message could include TIFF-FX attachment
   and non-TIFF-FX attachments.

   There is currently no mechanism to identify, in a returned MDN, the
   attachments that were successfully decoded from those that could not
   be decoded.

   If the Extended Mode recipient is unable to decode any of the
   attached files, it is recommended that the Extended Mode recipient
   return a decoding error for the entire message.
---------------------------------------------------------------------------

This is NOT to intend page-by-page confirmation. As you already know,
We cannot have the page-by-page confirmation in RFC2532. Therefore,
this description is reasonable, I think.

Please do not complicate it.

If you stick to it, you should propose in your I-Ds.

> I do not mean that the partial deliver notification is required in the 

With regard to this issue, please respond in the corresponding thread.

Regards,

---

From: MAEDA toru <[email-masked]>
Date: Mon, 26 Feb 2001 19:24:00 +0900

Tamura-san

Thank you for clarification about m,y question.

>MAEDA-san,

...

>this description is reasonable, I think.

Yes, it is reasonable for us.
But you can have the page-by-page confirmation if you want.

>Please do not complicate it.

I did not mean it.
I wanted to confirm that your ID describes about multiple files.

>If you stick to it, you should propose in your I-Ds.

Yes, I have submitted the ID "fax processing status".

>With regard to this issue, please respond in the corresponding thread.

I did not mean more than I wrote.

Regards.

Toru Maeda

--------------------
MAEDA TORU
MIE Development Div. 2
CANON Inc.
--------------------